(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@tsparticles/engine", "./EmittersCircleShapeGenerator.js"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.loadEmittersShapeCircle = loadEmittersShapeCircle;
    const engine_1 = require("@tsparticles/engine");
    const EmittersCircleShapeGenerator_js_1 = require("./EmittersCircleShapeGenerator.js");
    async function loadEmittersShapeCircle(engine, refresh = true) {
        const emittersEngine = engine;
        (0, engine_1.assertValidVersion)(emittersEngine, "3.7.1");
        emittersEngine.addEmitterShapeGenerator?.("circle", new EmittersCircleShapeGenerator_js_1.EmittersCircleShapeGenerator());
        await emittersEngine.refresh(refresh);
    }
});
